SystemOrganization addCategory: #'Sight-Dynamic'!
SystemOrganization addCategory: #'Sight-Dynamic-UI'!
SystemOrganization addCategory: #'Sight-Dynamic-Models'!
SystemOrganization addCategory: #'Sight-Dynamic-Testbed'!
SystemOrganization addCategory: #'Sight-Dynamic-Events'!
SystemOrganization addCategory: #'Sight-Dynamic-Tests'!

AbstractEvent subclass: #SdMessageEvent
	instanceVariableNames: 'text messageKind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Events'!

!SdMessageEvent commentStamp: 'mt 4/10/2011 11:17:28.228' prior: 0!
This system event is used to send text messages targeted at classes or messages. Different message kinds allow visual customization.!

!SdMessageEvent class methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:05:10.142'!
changeKind

	^ #Message! !

!SdMessageEvent class methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:06:00.826'!
supportedKinds

	^ {self classKind. self methodKind}! !

!SdMessageEvent class methodsFor: 'instance creation' stamp: 'mt 4/10/2011 11:16:43.624'!
text: stringOrText class: aClass

	^ self
		text: stringOrText
		kind: #information
		class: aClass! !

!SdMessageEvent class methodsFor: 'instance creation' stamp: 'mt 4/10/2011 11:16:26.427'!
text: stringOrText kind: messageKind class: aClass

	| instance |
	instance := self class: aClass.
	instance
		messageKind: messageKind;  
		text: stringOrText.
	^ instance! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:29.019'!
isError

	^ self messageKind = #error! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:11.069'!
isInformation

	^ self messageKind = #information! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:19.13'!
isWarning

	^ self messageKind = #warning! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:17:02.382'!
messageKind
	"The kind of a message can be used to display it differently."
	
	^ messageKind ifNil: [#information]! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:15:53.638'!
messageKind: aSymbol
	"#information, #warning, #error"
	
	messageKind := aSymbol! !

!SdMessageEvent methodsFor: 'printing' stamp: 'mt 4/10/2011 11:06:36.472'!
printEventKindOn: aStream

	aStream nextPutAll: 'Message'! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:09:44.207'!
text

	^ text! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:09:54.777'!
text: aText

	text := aText.! !

!SdMessageEvent methodsFor: 'triggering' stamp: 'mt 4/10/2011 11:24:38.657'!
trigger

	SystemChangeNotifier uniqueInstance trigger: self.! !

UserInterface subclass: #SdCallTreePanelUi
	instanceVariableNames: 'testClassCmb testCmb callTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI'!

!SdCallTreePanelUi methodsFor: 'accessing' stamp: 'mt 3/30/2011 09:58:24.882'!
callTree
	"nil"
	
	^ callTree! !

!SdCallTreePanelUi methodsFor: 'ui - private' stamp: 'mt 3/30/2011 09:58:24.957'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (200@472).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	testClassCmb := UiComboBox new.
	testClassCmb changeTableLayout.
	testClassCmb extent: (192@21).
	testClassCmb position: (4@4).
	testClassCmb hResizing: (#spaceFill).
	testClassCmb vResizing: (#shrinkWrap).
	testClassCmb cellInset: (0).
	testClassCmb cellPositioning: (#topLeft).
	testClassCmb cellSpacing: (#none).
	testClassCmb layoutInset: (0).
	testClassCmb listCentering: (#topLeft).
	testClassCmb listDirection: (#leftToRight).
	testClassCmb listSpacing: (#none).
	testClassCmb maxCellSize: (1073741823).
	testClassCmb minCellSize: (0).
	testClassCmb wrapCentering: (#topLeft).
	testClassCmb wrapDirection: (#none).
	testClassCmb frameFractions: (0@0 corner: 1@1).
	testClassCmb frameOffsets: (0@0 corner: 0@0).
	testClassCmb balloonText: (nil).
	testClassCmb balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	testClassCmb readOnly: (true).
	testClassCmb setProperty: #objectName toValue: 'testClassCmb'.
	panel addMorphBack: testClassCmb.
	testCmb := UiComboBox new.
	testCmb changeTableLayout.
	testCmb extent: (192@21).
	testCmb position: (4@29).
	testCmb hResizing: (#spaceFill).
	testCmb vResizing: (#shrinkWrap).
	testCmb cellInset: (0).
	testCmb cellPositioning: (#topLeft).
	testCmb cellSpacing: (#none).
	testCmb layoutInset: (0).
	testCmb listCentering: (#topLeft).
	testCmb listDirection: (#leftToRight).
	testCmb listSpacing: (#none).
	testCmb maxCellSize: (1073741823).
	testCmb minCellSize: (0).
	testCmb wrapCentering: (#topLeft).
	testCmb wrapDirection: (#none).
	testCmb frameFractions: (0@0 corner: 1@1).
	testCmb frameOffsets: (0@0 corner: 0@0).
	testCmb balloonText: (nil).
	testCmb balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	testCmb readOnly: (true).
	testCmb setProperty: #objectName toValue: 'testCmb'.
	panel addMorphBack: testCmb.
	callTree := UiTreeView new.
	callTree extent: (192@414).
	callTree position: (4@54).
	callTree hResizing: (#spaceFill).
	callTree vResizing: (#spaceFill).
	callTree cellInset: (0).
	callTree cellPositioning: (#center).
	callTree cellSpacing: (#none).
	callTree layoutInset: (0).
	callTree listCentering: (#topLeft).
	callTree listDirection: (#topToBottom).
	callTree listSpacing: (#none).
	callTree maxCellSize: (1073741823).
	callTree minCellSize: (0).
	callTree wrapCentering: (#topLeft).
	callTree wrapDirection: (#none).
	callTree frameFractions: (0@0 corner: 1@1).
	callTree frameOffsets: (0@0 corner: 0@0).
	callTree modelClass: (nil).
	callTree horizontalHeaderVisible: (true).
	callTree verticalHeaderVisible: (false).
	callTree selectionBehavior: (#selectRows).
	callTree selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	callTree selectionMode: (UiViewSingleSelection).
	callTree setProperty: #objectName toValue: 'callTree'.
	panel addMorphBack: callTree.
	panel setProperty: #uiClassName toValue: 'SdCallTreePanel'.! !

!SdCallTreePanelUi methodsFor: 'accessing' stamp: 'mt 3/30/2011 09:58:24.756'!
testClassCmb
	"nil"
	
	^ testClassCmb! !

!SdCallTreePanelUi methodsFor: 'accessing' stamp: 'mt 3/30/2011 09:58:24.836'!
testCmb
	"nil"
	
	^ testCmb! !

UserInterface subclass: #SdClassEditorUi
	instanceVariableNames: 'unnamedMorph1 unnamedMorph2 unnamedMorph3 classLbl unnamedMorph4 closeBtn topContainer unnamedMorph5 findBtn commentBtn unnamedMorph6 browseBtn codeArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI'!

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 4/12/2011 14:17:31.608'!
browseBtn
	"nil"
	
	^ browseBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 4/12/2011 14:17:31.305'!
classLbl
	"nil"
	
	^ classLbl! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 4/12/2011 14:17:31.367'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 4/12/2011 14:17:31.659'!
codeArea
	"nil"
	
	^ codeArea! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 4/12/2011 14:17:31.561'!
commentBtn
	"nil"
	
	^ commentBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 4/12/2011 14:17:31.513'!
findBtn
	"nil"
	
	^ findBtn! !

!SdClassEditorUi methodsFor: 'ui - private' stamp: 'mt 4/12/2011 14:17:31.765'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (244@569).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (236@19).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#center).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 extent: (20@5).
	unnamedMorph2 position: (7@11).
	unnamedMorph2 hResizing: (#rigid).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (72@10).
	unnamedMorph3 position: (34@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	classLbl := UiLabel new.
	classLbl changeTableLayout.
	classLbl extent: (27@19).
	classLbl position: (110@4).
	classLbl hResizing: (#shrinkWrap).
	classLbl vResizing: (#shrinkWrap).
	classLbl cellInset: (0).
	classLbl cellPositioning: (#center).
	classLbl cellSpacing: (#none).
	classLbl layoutInset: (0).
	classLbl listCentering: (#topLeft).
	classLbl listDirection: (#leftToRight).
	classLbl listSpacing: (#none).
	classLbl maxCellSize: (1073741823).
	classLbl minCellSize: (0).
	classLbl wrapCentering: (#topLeft).
	classLbl wrapDirection: (#none).
	classLbl frameFractions: (0@0 corner: 1@1).
	classLbl frameOffsets: (0@0 corner: 0@0).
	classLbl balloonText: (nil).
	classLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	classLbl text: ('Class').
	classLbl setProperty: #formByDesigner toValue: 'nil'.
	classLbl form: (nil).
	classLbl setProperty: #objectName toValue: 'classLbl'.
	unnamedMorph1 addMorphBack: classLbl.
	unnamedMorph4 := UiSpacer new.
	unnamedMorph4 extent: (73@12).
	unnamedMorph4 position: (141@7).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	unnamedMorph4 color: (Color blue).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph4 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (22@18).
	closeBtn position: (218@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (2@0 corner: 2@0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons deleteIcon'.
	closeBtn icon: (UiSilkIcons deleteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	topContainer := UiContainer new.
	topContainer changeTableLayout.
	topContainer extent: (236@21).
	topContainer position: (4@24).
	topContainer hResizing: (#spaceFill).
	topContainer vResizing: (#shrinkWrap).
	topContainer cellInset: (4).
	topContainer cellPositioning: (#center).
	topContainer cellSpacing: (#none).
	topContainer layoutInset: (0).
	topContainer listCentering: (#topLeft).
	topContainer listDirection: (#topToBottom).
	topContainer listSpacing: (#none).
	topContainer maxCellSize: (1073741823).
	topContainer minCellSize: (0).
	topContainer wrapCentering: (#topLeft).
	topContainer wrapDirection: (#none).
	topContainer frameFractions: (0@0 corner: 1@1).
	topContainer frameOffsets: (0@0 corner: 0@0).
	topContainer balloonText: (nil).
	topContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	topContainer color: (Color transparent).
	topContainer borderWidth: (0).
	topContainer borderStyle2: (#simple).
	topContainer borderColor: (Color black).
	topContainer setProperty: #objectName toValue: 'topContainer'.
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (236@18).
	unnamedMorph5 position: (4@24).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#shrinkWrap).
	unnamedMorph5 cellInset: (0).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#leftToRight).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	findBtn := UiToolButton new.
	findBtn changeTableLayout.
	findBtn extent: (22@18).
	findBtn position: (4@24).
	findBtn hResizing: (#shrinkWrap).
	findBtn vResizing: (#shrinkWrap).
	findBtn cellInset: (4).
	findBtn cellPositioning: (#center).
	findBtn cellSpacing: (#none).
	findBtn layoutInset: (2@0 corner: 2@0).
	findBtn listCentering: (#topLeft).
	findBtn listDirection: (#leftToRight).
	findBtn listSpacing: (#none).
	findBtn maxCellSize: (1073741823).
	findBtn minCellSize: (0).
	findBtn wrapCentering: (#topLeft).
	findBtn wrapDirection: (#none).
	findBtn frameFractions: (0@0 corner: 1@1).
	findBtn frameOffsets: (0@0 corner: 0@0).
	findBtn balloonText: ('Find Method').
	findBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	findBtn enabled: (true).
	findBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons magnifierIcon'.
	findBtn icon: (UiFugueIcons magnifierIcon).
	findBtn text: ('ToolButton').
	findBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	findBtn checkable: (true).
	findBtn checked: (false).
	findBtn autoExclusive: (false).
	findBtn autoRaise: (true).
	findBtn buttonStyle: (#iconOnly).
	findBtn setProperty: #objectName toValue: 'findBtn'.
	unnamedMorph5 addMorphBack: findBtn.
	commentBtn := UiToolButton new.
	commentBtn changeTableLayout.
	commentBtn extent: (22@18).
	commentBtn position: (26@24).
	commentBtn hResizing: (#shrinkWrap).
	commentBtn vResizing: (#shrinkWrap).
	commentBtn cellInset: (4).
	commentBtn cellPositioning: (#center).
	commentBtn cellSpacing: (#none).
	commentBtn layoutInset: (2@0 corner: 2@0).
	commentBtn listCentering: (#topLeft).
	commentBtn listDirection: (#leftToRight).
	commentBtn listSpacing: (#none).
	commentBtn maxCellSize: (1073741823).
	commentBtn minCellSize: (0).
	commentBtn wrapCentering: (#topLeft).
	commentBtn wrapDirection: (#none).
	commentBtn frameFractions: (0@0 corner: 1@1).
	commentBtn frameOffsets: (0@0 corner: 0@0).
	commentBtn balloonText: ('Edit class comment').
	commentBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	commentBtn enabled: (true).
	commentBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons commentIcon'.
	commentBtn icon: (UiSilkIcons commentIcon).
	commentBtn text: ('ToolButton').
	commentBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	commentBtn checkable: (true).
	commentBtn checked: (false).
	commentBtn autoExclusive: (false).
	commentBtn autoRaise: (true).
	commentBtn buttonStyle: (#iconOnly).
	commentBtn setProperty: #objectName toValue: 'commentBtn'.
	unnamedMorph5 addMorphBack: commentBtn.
	unnamedMorph6 := UiSpacer new.
	unnamedMorph6 extent: (170@13).
	unnamedMorph6 position: (48@27).
	unnamedMorph6 hResizing: (#spaceFill).
	unnamedMorph6 vResizing: (#rigid).
	unnamedMorph6 cellInset: (4).
	unnamedMorph6 cellPositioning: (#center).
	unnamedMorph6 cellSpacing: (#none).
	unnamedMorph6 layoutInset: (4).
	unnamedMorph6 listCentering: (#topLeft).
	unnamedMorph6 listDirection: (#topToBottom).
	unnamedMorph6 listSpacing: (#none).
	unnamedMorph6 maxCellSize: (1073741823).
	unnamedMorph6 minCellSize: (0).
	unnamedMorph6 wrapCentering: (#topLeft).
	unnamedMorph6 wrapDirection: (#none).
	unnamedMorph6 frameFractions: (0@0 corner: 1@1).
	unnamedMorph6 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph6 balloonText: (nil).
	unnamedMorph6 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	unnamedMorph6 color: (Color blue).
	unnamedMorph6 borderWidth: (0).
	unnamedMorph6 borderStyle2: (#simple).
	unnamedMorph6 borderColor: (Color black).
	unnamedMorph6 orientation: (#horizontal).
	unnamedMorph5 addMorphBack: unnamedMorph6.
	browseBtn := UiToolButton new.
	browseBtn changeTableLayout.
	browseBtn extent: (22@18).
	browseBtn position: (218@24).
	browseBtn hResizing: (#shrinkWrap).
	browseBtn vResizing: (#shrinkWrap).
	browseBtn cellInset: (4).
	browseBtn cellPositioning: (#center).
	browseBtn cellSpacing: (#none).
	browseBtn layoutInset: (2@0 corner: 2@0).
	browseBtn listCentering: (#topLeft).
	browseBtn listDirection: (#leftToRight).
	browseBtn listSpacing: (#none).
	browseBtn maxCellSize: (1073741823).
	browseBtn minCellSize: (0).
	browseBtn wrapCentering: (#topLeft).
	browseBtn wrapDirection: (#none).
	browseBtn frameFractions: (0@0 corner: 1@1).
	browseBtn frameOffsets: (0@0 corner: 0@0).
	browseBtn balloonText: ('Browse Classes').
	browseBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	browseBtn enabled: (true).
	browseBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons folderExploreIcon'.
	browseBtn icon: (UiSilkIcons folderExploreIcon).
	browseBtn text: ('ToolButton').
	browseBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	browseBtn checkable: (false).
	browseBtn checked: (false).
	browseBtn autoExclusive: (false).
	browseBtn autoRaise: (true).
	browseBtn buttonStyle: (#iconOnly).
	browseBtn setProperty: #objectName toValue: 'browseBtn'.
	unnamedMorph5 addMorphBack: browseBtn.
	topContainer addMorphBack: unnamedMorph5.
	panel addMorphBack: topContainer.
	codeArea := UiScrollArea new.
	codeArea extent: (236@520).
	codeArea position: (4@45).
	codeArea hResizing: (#spaceFill).
	codeArea vResizing: (#spaceFill).
	codeArea cellInset: (0).
	codeArea cellPositioning: (#center).
	codeArea cellSpacing: (#none).
	codeArea layoutInset: (0).
	codeArea listCentering: (#topLeft).
	codeArea listDirection: (#topToBottom).
	codeArea listSpacing: (#none).
	codeArea maxCellSize: (1073741823).
	codeArea minCellSize: (0).
	codeArea wrapCentering: (#topLeft).
	codeArea wrapDirection: (#none).
	codeArea frameFractions: (0@0 corner: 1@1).
	codeArea frameOffsets: (0@0 corner: 0@0).
	codeArea balloonText: (nil).
	codeArea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	codeArea widgetResizable: (true).
	codeArea horizontalScrollBarPolicy: (#alwaysOff).
	codeArea verticalScrollBarPolicy: (#asNeeded).
	codeArea outerBorderWidth: (0).
	codeArea setProperty: #objectName toValue: 'codeArea'.
	panel addMorphBack: codeArea.
	panel setProperty: #uiClassName toValue: 'SdClassEditor'.! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 4/12/2011 14:17:31.444'!
topContainer
	"nil"
	
	^ topContainer! !

UserInterface subclass: #SdClassSelectorUi
	instanceVariableNames: 'unnamedMorph1 classTree unnamedMorph2 classEdit actionBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI'!

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 4/11/2011 14:07:06.654'!
actionBtn
	"nil"
	
	^ actionBtn! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 4/11/2011 14:07:06.592'!
classEdit
	"nil"
	
	^ classEdit! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 4/11/2011 14:07:06.495'!
classTree
	"nil"
	
	^ classTree! !

!SdClassSelectorUi methodsFor: 'ui - private' stamp: 'mt 4/11/2011 14:07:06.734'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (248@388).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: ('').
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiLabel new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (79@19).
	unnamedMorph1 position: (85@4).
	unnamedMorph1 hResizing: (#shrinkWrap).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 text: ('Choose a Class').
	unnamedMorph1 setProperty: #formByDesigner toValue: 'nil'.
	unnamedMorph1 form: (nil).
	panel addMorphBack: unnamedMorph1.
	classTree := UiTreeView new.
	classTree extent: (240@331).
	classTree position: (4@27).
	classTree hResizing: (#spaceFill).
	classTree vResizing: (#spaceFill).
	classTree cellInset: (0).
	classTree cellPositioning: (#center).
	classTree cellSpacing: (#none).
	classTree layoutInset: (0).
	classTree listCentering: (#topLeft).
	classTree listDirection: (#topToBottom).
	classTree listSpacing: (#none).
	classTree maxCellSize: (1073741823).
	classTree minCellSize: (0).
	classTree wrapCentering: (#topLeft).
	classTree wrapDirection: (#none).
	classTree frameFractions: (0@0 corner: 1@1).
	classTree frameOffsets: (0@0 corner: 0@0).
	classTree balloonText: (nil).
	classTree balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	classTree widgetResizable: (false).
	classTree horizontalScrollBarPolicy: (#asNeeded).
	classTree verticalScrollBarPolicy: (#asNeeded).
	classTree outerBorderWidth: (0).
	classTree modelClass: (nil).
	classTree horizontalHeaderVisible: (true).
	classTree verticalHeaderVisible: (false).
	classTree selectionBehavior: (#selectRows).
	classTree selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	classTree selectionMode: (UiViewSingleSelection).
	classTree setProperty: #objectName toValue: 'classTree'.
	panel addMorphBack: classTree.
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (240@22).
	unnamedMorph2 position: (4@362).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	classEdit := UiLineEdit new.
	classEdit extent: (216@20).
	classEdit position: (4@363).
	classEdit hResizing: (#spaceFill).
	classEdit vResizing: (#rigid).
	classEdit cellInset: (0).
	classEdit cellPositioning: (#center).
	classEdit cellSpacing: (#none).
	classEdit layoutInset: (0).
	classEdit listCentering: (#topLeft).
	classEdit listDirection: (#topToBottom).
	classEdit listSpacing: (#none).
	classEdit maxCellSize: (1073741823).
	classEdit minCellSize: (0).
	classEdit wrapCentering: (#topLeft).
	classEdit wrapDirection: (#none).
	classEdit frameFractions: (0@0 corner: 1@1).
	classEdit frameOffsets: (0@0 corner: 0@0).
	classEdit balloonText: (nil).
	classEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	classEdit widgetResizable: (false).
	classEdit horizontalScrollBarPolicy: (#alwaysOff).
	classEdit verticalScrollBarPolicy: (#alwaysOff).
	classEdit outerBorderWidth: (1).
	classEdit theText: ('').
	classEdit readOnly: (false).
	classEdit autoConvert: (false).
	classEdit autoAccept: (false).
	classEdit acceptOnFocusLost: (true).
	classEdit helpText: ('').
	classEdit setProperty: #objectName toValue: 'classEdit'.
	unnamedMorph2 addMorphBack: classEdit.
	actionBtn := UiToolButton new.
	actionBtn changeTableLayout.
	actionBtn extent: (20@16).
	actionBtn position: (224@365).
	actionBtn hResizing: (#shrinkWrap).
	actionBtn vResizing: (#shrinkWrap).
	actionBtn cellInset: (4).
	actionBtn cellPositioning: (#center).
	actionBtn cellSpacing: (#none).
	actionBtn layoutInset: (2@0 corner: 2@0).
	actionBtn listCentering: (#topLeft).
	actionBtn listDirection: (#leftToRight).
	actionBtn listSpacing: (#none).
	actionBtn maxCellSize: (1073741823).
	actionBtn minCellSize: (0).
	actionBtn wrapCentering: (#topLeft).
	actionBtn wrapDirection: (#none).
	actionBtn frameFractions: (0@0 corner: 1@1).
	actionBtn frameOffsets: (0@0 corner: 0@0).
	actionBtn balloonText: (nil).
	actionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	actionBtn enabled: (true).
	actionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons pencilIcon'.
	actionBtn icon: (UiSilkIcons pencilIcon).
	actionBtn text: ('ToolButton').
	actionBtn color: (Color transparent).
	actionBtn checkable: (false).
	actionBtn checked: (false).
	actionBtn autoExclusive: (false).
	actionBtn autoRaise: (true).
	actionBtn buttonStyle: (#iconOnly).
	actionBtn setProperty: #objectName toValue: 'actionBtn'.
	unnamedMorph2 addMorphBack: actionBtn.
	panel addMorphBack: unnamedMorph2.
	panel setProperty: #uiClassName toValue: 'SdClassSelector'.! !

UserInterface subclass: #SdMethodFinderUi
	instanceVariableNames: 'unnamedMorph1 searchField actionBtn resultList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI'!

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/6/2011 15:33:26.015'!
actionBtn
	"nil"
	
	^ actionBtn! !

!SdMethodFinderUi methodsFor: 'ui - private' stamp: 'mt 4/6/2011 15:33:26.123'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (218@100).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#shrinkWrap).
	panel cellInset: (0).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (210@22).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	unnamedMorph1 color: (Color white).
	unnamedMorph1 borderWidth: (1).
	unnamedMorph1 borderStyle2: (#inset).
	unnamedMorph1 borderColor: (#inset).
	searchField := UiLineEdit new.
	searchField extent: (182@20).
	searchField position: (5@5).
	searchField hResizing: (#spaceFill).
	searchField vResizing: (#rigid).
	searchField cellInset: (0).
	searchField cellPositioning: (#center).
	searchField cellSpacing: (#none).
	searchField layoutInset: (0).
	searchField listCentering: (#topLeft).
	searchField listDirection: (#topToBottom).
	searchField listSpacing: (#none).
	searchField maxCellSize: (1073741823).
	searchField minCellSize: (0).
	searchField wrapCentering: (#topLeft).
	searchField wrapDirection: (#none).
	searchField frameFractions: (0@0 corner: 1@1).
	searchField frameOffsets: (0@0 corner: 0@0).
	searchField balloonText: (nil).
	searchField balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	searchField widgetResizable: (false).
	searchField horizontalScrollBarPolicy: (#alwaysOff).
	searchField verticalScrollBarPolicy: (#alwaysOff).
	searchField outerBorderWidth: (0).
	searchField theText: ('').
	searchField readOnly: (false).
	searchField autoConvert: (false).
	searchField autoAccept: (false).
	searchField acceptOnFocusLost: (true).
	searchField helpText: ('').
	searchField setProperty: #objectName toValue: 'searchField'.
	unnamedMorph1 addMorphBack: searchField.
	actionBtn := UiToolButton new.
	actionBtn changeTableLayout.
	actionBtn extent: (22@18).
	actionBtn position: (191@6).
	actionBtn hResizing: (#shrinkWrap).
	actionBtn vResizing: (#shrinkWrap).
	actionBtn cellInset: (4).
	actionBtn cellPositioning: (#center).
	actionBtn cellSpacing: (#none).
	actionBtn layoutInset: (2@0 corner: 2@0).
	actionBtn listCentering: (#topLeft).
	actionBtn listDirection: (#leftToRight).
	actionBtn listSpacing: (#none).
	actionBtn maxCellSize: (1073741823).
	actionBtn minCellSize: (0).
	actionBtn wrapCentering: (#topLeft).
	actionBtn wrapDirection: (#none).
	actionBtn frameFractions: (0@0 corner: 1@1).
	actionBtn frameOffsets: (0@0 corner: 0@0).
	actionBtn balloonText: (nil).
	actionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	actionBtn enabled: (true).
	actionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons addIcon'.
	actionBtn icon: (UiSilkIcons addIcon).
	actionBtn text: ('ToolButton').
	actionBtn color: (Color transparent).
	actionBtn checkable: (false).
	actionBtn checked: (false).
	actionBtn autoExclusive: (false).
	actionBtn autoRaise: (true).
	actionBtn buttonStyle: (#iconOnly).
	actionBtn setProperty: #objectName toValue: 'actionBtn'.
	actionBtn setProperty: #objectDescription toValue: 'This button triggers the main action for the given text.'.
	unnamedMorph1 addMorphBack: actionBtn.
	panel addMorphBack: unnamedMorph1.
	resultList := UiListWidget new.
	resultList extent: (210@70).
	resultList position: (4@26).
	resultList hResizing: (#spaceFill).
	resultList vResizing: (#rigid).
	resultList cellInset: (0).
	resultList cellPositioning: (#center).
	resultList cellSpacing: (#none).
	resultList layoutInset: (0).
	resultList listCentering: (#topLeft).
	resultList listDirection: (#topToBottom).
	resultList listSpacing: (#none).
	resultList maxCellSize: (1073741823).
	resultList minCellSize: (0).
	resultList wrapCentering: (#topLeft).
	resultList wrapDirection: (#none).
	resultList frameFractions: (0@0 corner: 1@1).
	resultList frameOffsets: (0@0 corner: 0@0).
	resultList balloonText: (nil).
	resultList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	resultList widgetResizable: (false).
	resultList horizontalScrollBarPolicy: (#alwaysOff).
	resultList verticalScrollBarPolicy: (#asNeeded).
	resultList outerBorderWidth: (0).
	resultList modelClass: (UiListWidgetModel).
	resultList horizontalHeaderVisible: (false).
	resultList verticalHeaderVisible: (false).
	resultList selectionBehavior: (#selectRows).
	resultList selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	resultList selectionMode: (UiViewSingleSelection).
	resultList setProperty: #objectName toValue: 'resultList'.
	panel addMorphBack: resultList.
	panel setProperty: #uiClassName toValue: 'SdMethodFinder'.! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/6/2011 15:33:26.055'!
resultList
	"nil"
	
	^ resultList! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/6/2011 15:33:25.943'!
searchField
	"nil"
	
	^ searchField! !

Morph subclass: #SdClassElementEditor
	instanceVariableNames: 'theClass toolbar toolbarVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassElementEditor commentStamp: 'mt 4/6/2011 16:01:42.402' prior: 0!
This is an editor for a class element, e.g. a method, the comment...!

SdClassElementEditor subclass: #SdClassEditor
	instanceVariableNames: 'ui sui finder commentEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassEditor commentStamp: 'mt 4/6/2011 16:27:07.935' prior: 0!
This is an editor for a whole class.

SdClassEditor new
	width: 500;
	theClass: String;
	openInWorld.!

!SdClassEditor class methodsFor: 'testing' stamp: 'mt 3/25/2011 17:05:25.965'!
isWidgetClass

	^ false! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/11/2011 16:49:39.13'!
addMethodEditor: aSelector

	| m |
	self theClass ifNil: [^ self].

	(self methodEditors
		detect: [:methodEditor | methodEditor selector = aSelector]
		ifNone: []) ifNotNil: [:methodEditor |
			self ui codeArea scrollToShow: (methodEditor topLeft extent: 20@20).
			^ self].

	m := SdMethodEditor new
			theClass: self theClass
			selector: aSelector;
			hResizing: #spaceFill.
			
	self editors addMorphBack: m.
		
	m expand.
	finder grabKeyboard.
	
	self connect: m signal: #focusChanged: toSelector: #onFocusChanged:.
	
	self connect: m sourceCodeEdit signal: #mouseWheelUp: to: self ui codeArea verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: m sourceCodeEdit signal: #mouseWheelDown: to: self ui codeArea verticalScrollBar selector: #increaseValueBySingleStep.! !

!SdClassEditor methodsFor: 'class - actions' stamp: 'mt 4/11/2011 16:09:24.85'!
chooseClass

	| class |
	class := Smalltalk
		at: self sui classEdit theText asString asSymbol
		ifAbsent: [].
		
	class ifNil: [^ self].
	
	self theClass: class; switchToEditUi.! !

!SdClassEditor methodsFor: 'class - actions' stamp: 'mt 4/11/2011 16:37:49.956'!
chooseClass: aModelIndex

	| class |
	class := Smalltalk
		at: (self sui classTree model textFor: aModelIndex) asString asSymbol
		ifAbsent: [].
		
	class ifNil: [^ self].
	
	self theClass: class; switchToEditUi.! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 4/12/2011 14:14:47.278'!
editorChange: aSymbol

	aSymbol = #class
		ifTrue: [
			"Visually inform the user about the new class."
			self ui classLbl text: ('<b>', self theClass name, '</b>') asHtmlText.
			
			"Inform method finder about new class."
			self finder theClass: self theClass.
			
			"Reset comment editor."
			self loadClassComment.
			
			"Reset editors for new class."
			self editors removeAllMorphs].! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 4/6/2011 16:13:52.204'!
editors
	"Container where all class element editors are stored."
	
	^ self ui codeArea widget! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 4/6/2011 16:14:29.696'!
finder

	^ finder! !

!SdClassEditor methodsFor: 'layouting' stamp: 'mt 4/11/2011 10:43:31.531'!
hideTopContainer

	self ui topContainer
		hide;
		disableTableLayout: true.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/12/2011 14:13:54.5'!
initialize

	super initialize.
	
	finder := SdMethodFinder new hResizing: #spaceFill.
	
	commentEditor := UiTextEdit new hResizing: #spaceFill.
	self connect: commentEditor signal: #editingFinished: toSelector: #saveClassComment.
	
	self
		initializeSystemChangeNotifications;
		initializeEditUi;
		initializeSelectUi;
		switchToSelectUi.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/12/2011 14:10:04.514'!
initializeEditUi

	self ui initializePanel.

	self ui codeArea verticalScrollBar singleStep: 20.
	
	self ui codeArea widget: (Morph new
		changeTableLayout;
		color: Color transparent;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom).
	
	self ui topContainer addMorphBack: finder.
	self toggleFinder.
		
	self connect: self ui findBtn signal: #toggled: toSelector: #toggleFinder.
	self connect: finder signal: #selectorChosen: toSelector: #addMethodEditor:.
	
	self connect: self ui browseBtn signal: #clicked: toSelector: #switchToSelectUi.
	self connect: self ui closeBtn signal: #clicked: toSelector: #delete.
	
	self connect: self ui commentBtn signal: #toggled: toSelector: #toggleCommentEditor.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/11/2011 16:38:02.066'!
initializeSelectUi

	self sui initializePanel.
	
	self sui classTree
		removeHorizontalHeader;
		enableAutoSort;
		model: SdClassTreeModel new.
		
	self connect: self sui classTree signal: #currentIndexChanged: toSelector: #onClassSelectionChanged:.
	self connect: self sui actionBtn signal: #clicked: toSelector: #chooseClass.

	self connect: self sui classTree signal: #returnPressed: toSelector: #chooseClass:.
	self connect: self sui classTree signal: #doubleClicked: toSelector: #chooseClass:.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/12/2011 14:22:12.396'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: SystemChangeNotifier methodKind using: #onMethodChange:;
		notify: self ofSystemChangesOfItem: SystemChangeNotifier classKind using: #onClassChange:;
		notify: self ofSystemChangesOfChange: SdMessageEvent changeKind using: #onMessageReceive:.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 14:16:14.727'!
loadClassComment

	commentEditor theText: self theClass organization classComment.
	self updateCommentBtn.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 4/6/2011 16:30:50.473'!
methodEditors

	^ self editors submorphs
		select: [:classElementEditor | classElementEditor isMethodEditor]! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/12/2011 14:21:49.905'!
onClassChange: classKindEvent

	"| locationString |"
	classKindEvent itemClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
"	locationString := methodKindEvent itemClass asString, '\>\> ', methodKindEvent itemSelector asString.
	methodKindEvent isModified
		ifTrue: [self showInformation: ('Modified: <b>', locationString, '</b>') asHtmlText].
	methodKindEvent isRemoved
		ifTrue: [self showInformation: ('Removed: ', locationString) asHtmlText].
	methodKindEvent isAdded
		ifTrue: [self showInformation: ('Added: ', locationString) asHtmlText]."! !

!SdClassEditor methodsFor: 'class - actions' stamp: 'mt 4/11/2011 14:52:31.467'!
onClassSelectionChanged: aModelIndex

	| class |
	class := Smalltalk
		at: (self sui classTree model textFor: aModelIndex) asString asSymbol
		ifAbsent: [].
		
	class ifNil: [^ self].
	
	self sui classEdit theText: class name.! !

!SdClassEditor methodsFor: 'focus' stamp: 'mt 4/8/2011 12:13:53.325'!
onFocusChanged: aGlobalRectangle

	self ui codeArea scrollToShow: 
		((self editors globalPointToLocal: aGlobalRectangle topLeft)
			extent: aGlobalRectangle extent).! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/10/2011 11:26:35.411'!
onMessageReceive: messageEvent

	messageEvent itemClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	messageEvent isInformation ifTrue: [self showInformation: messageEvent text].
	messageEvent isWarning ifTrue: [self showWarning: messageEvent text].
	messageEvent isError ifTrue: [self showError: messageEvent text].! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/11/2011 10:39:07.46'!
onMethodChange: methodKindEvent

	| locationString |
	methodKindEvent itemClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	locationString := methodKindEvent itemClass asString, '\>\> ', methodKindEvent itemSelector asString.
	methodKindEvent isModified
		ifTrue: [self showInformation: ('Modified: <b>', locationString, '</b>') asHtmlText].
	methodKindEvent isRemoved
		ifTrue: [self showInformation: ('Removed: ', locationString) asHtmlText].
	methodKindEvent isAdded
		ifTrue: [self showInformation: ('Added: ', locationString) asHtmlText].! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/10/2011 11:33:59.459'!
positionForNextMessage

	| corner |
	corner := self ui codeArea viewportBounds bottomRight.
	^ corner + (-1 @ 
			(((self submorphs
				select: [:m | m isKindOf: UiMessage]
				thenCollect: [:m | m top + 1]), {corner y}) min - corner y))! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 14:16:19.323'!
saveClassComment

	self theClass comment: commentEditor theText.
	self updateCommentBtn.! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/8/2011 12:41:36.867'!
showError: aText
		
	self addMorph: ((UiMessage error: aText)
		disableTableLayout: true;  
		bottomRight: self positionForNextMessage).! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/10/2011 11:26:35.321'!
showInformation: aText
		
	self addMorph: ((UiMessage information: aText)
		disableTableLayout: true;  
		bottomRight: self positionForNextMessage).! !

!SdClassEditor methodsFor: 'layouting' stamp: 'mt 4/11/2011 14:18:43.761'!
showTopContainer

	self ui topContainer
		show;
		disableTableLayout: false.! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/8/2011 12:40:05.831'!
showWarning: aText
		
	self addMorph: ((UiMessage warning: aText)
		disableTableLayout: true;  
		bottomRight: self positionForNextMessage).! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 4/11/2011 14:07:50.128'!
sui

	^ sui ifNil: [sui := SdClassSelectorUi new]! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/12/2011 13:55:57.364'!
switchToEditUi

	self removeAllMorphs.
	self ui setupUi: self.
	
	self ui findBtn checked: true.
	finder grabKeyboard.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/11/2011 14:10:02.12'!
switchToSelectUi

	self removeAllMorphs.
	self sui setupUi: self.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 14:20:57.617'!
toggleCommentEditor

	self ui commentBtn checked
		ifTrue: [self ui topContainer addMorphBack: commentEditor]
		ifFalse: [commentEditor delete].
		
	commentEditor grabKeyboard.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 14:20:51.24'!
toggleFinder

	self ui findBtn checked
		ifTrue: [self ui topContainer addMorphBack: finder"finder disableTableLayout: false; show"]
		ifFalse: [finder delete" disableTableLayout: true; hide"].
		
	finder grabKeyboard.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 3/29/2011 10:48:12.049'!
ui

	^ ui ifNil: [ui := SdClassEditorUi new]! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 4/12/2011 14:16:04.294'!
updateCommentBtn

	commentEditor theText
		ifEmpty: [self ui commentBtn icon: UiSilkIcons commentAddIcon]
		ifNotEmpty: [self ui commentBtn icon: UiSilkIcons commentIcon].! !

!SdClassElementEditor methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 17:39:09.148'!
doLayoutIn: layoutBounds

	super doLayoutIn: layoutBounds.
	  
	"Update toolbar bounds."
	self toolbar ifNotNil: [:tb |
		tb bounds: ((self localPointToGlobal: self topLeft) extent: self bounds extent)].! !

!SdClassElementEditor methodsFor: 'updating' stamp: 'mt 4/6/2011 16:06:40.85'!
editorChange: aSymbol
	"#class"
	
	! !

!SdClassElementEditor methodsFor: 'toolbar' stamp: 'mt 4/7/2011 17:16:16.644'!
hideToolbar

	self toolbarVisible ifFalse: [^ self].
	
	self toolbar delete.! !

!SdClassElementEditor methodsFor: 'initialization' stamp: 'mt 4/7/2011 17:10:50.53'!
initialize

	super initialize.
	
	self initializeEventHandler.! !

!SdClassElementEditor methodsFor: 'initialization' stamp: 'mt 4/11/2011 13:52:18.821'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self eventHandler grabKeyboardOnMouseEnter: false.  
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #showToolbar.! !

!SdClassElementEditor methodsFor: 'testing' stamp: 'mt 4/6/2011 16:23:21.581'!
isMethodEditor

	^ false! !

!SdClassElementEditor methodsFor: 'toolbar' stamp: 'mt 4/7/2011 17:15:22.705'!
showToolbar

	self toolbarVisible ifFalse: [^ self].
	
	self toolbar popUpAt: (self localPointToGlobal: self topLeft).! !

!SdClassElementEditor methodsFor: 'accessing' stamp: 'mt 4/6/2011 15:59:54.201'!
theClass

	^ theClass! !

!SdClassElementEditor methodsFor: 'accessing' stamp: 'mt 4/6/2011 16:07:02.498'!
theClass: aClassOrMetaClass

	theClass = aClassOrMetaClass ifTrue: [^ self].

	theClass := aClassOrMetaClass.
	
	self editorChange: #class.! !

!SdClassElementEditor methodsFor: 'accessing' stamp: 'mt 4/7/2011 17:05:54.576'!
toolbar

	^ toolbar! !

!SdClassElementEditor methodsFor: 'accessing' stamp: 'mt 4/7/2011 17:22:27.399'!
toolbar: aToolbar

	toolbar := aToolbar.
	toolbar ifNotNil: [self toolbarVisible: true].! !

!SdClassElementEditor methodsFor: 'accessing' stamp: 'mt 4/7/2011 17:07:39.175'!
toolbarVisible

	^ self toolbar notNil and: [toolbarVisible ifNil: [false]]! !

!SdClassElementEditor methodsFor: 'accessing' stamp: 'mt 4/7/2011 17:37:59.467'!
toolbarVisible: aBoolean

	toolbarVisible := aBoolean.
	
	aBoolean
		ifFalse: [self toolbar ifNotNil: [:tb | tb delete]].! !

SdClassElementEditor subclass: #SdMethodEditor
	instanceVariableNames: 'sourceCodeEdit toggleBtn separator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/11/2011 11:26:23.287'!
collapse

	toggleBtn checked: false.! !

!SdMethodEditor methodsFor: 'submorphs-add/remove' stamp: 'mt 4/11/2011 11:32:12.156'!
delete

	super delete.
	self toolbar delete.! !

!SdMethodEditor methodsFor: 'updating' stamp: 'mt 4/6/2011 16:07:29.324'!
editorChange: aSymbol
	
	self updateLayout.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/6/2011 16:36:26.142'!
expand

	toggleBtn checked: true.  ! !

!SdMethodEditor methodsFor: 'signals' stamp: 'mt 4/8/2011 11:19:22.195'!
focusChanged: aRectangle

	self emitAlways.  ! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 4/11/2011 16:50:29.315'!
initialize

	super initialize.

	sourceCodeEdit := SdSourceCodeEdit new
		hResizing: #spaceFill.
	"sourceCodeEdit textMorph margins: (20@0 corner: 3@0)."
	sourceCodeEdit
		verticalScrollBarPolicy: #alwaysOff;
		areaResizable: true;
		outerBorderWidth: 0.
	self connect: sourceCodeEdit signal: #focusChanged: toSelector: #focusChanged:.

	self initializeToolbar.

	toggleBtn := UiPushButton new checkable: true.
	
	separator := Morph new
		extent: 10@1;
		color: Color black;
		hResizing: #spaceFill.
		
	self
		color: Color transparent;
		changeTableLayout;
		listDirection: #topToBottom;
		vResizing: #shrinkWrap;  
		addMorphBack: toggleBtn;
		addMorphBack: sourceCodeEdit;
		addMorphBack: separator;
		updateLayout.
		
	self connect: toggleBtn signal: #toggled: toSelector: #updateLayout.
	self connect: toggleBtn signal: #clicked: to: self selector: #showToolbar.
"	self connect: sourceCodeEdit signal: #sourceCodeResetted toSelector: #updateLayout."! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 4/11/2011 13:33:58.32'!
initializeToolbar

	| closeBtn collapseBtn |
	self toolbar: SdFadingToolbar new.
	
	collapseBtn := UiToolButton new
		autoRaise: true;
		color: Color transparent;  
		buttonStyle: #iconOnly;
		icon: UiFugueIcons toggleSmallIcon;
		balloonText: 'Collapse method'.
	self connect: collapseBtn signal: #clicked: toSelector: #collapse.
	
	self toolbar addButton: collapseBtn edge: #top.

	closeBtn := UiToolButton new
		autoRaise: true;
		color: Color transparent;  
		buttonStyle: #iconOnly;
		icon: UiSilkIcons eyeIcon;
		balloonText: 'Hide method'.
	self connect: closeBtn signal: #clicked: toSelector: #delete.
	
	self toolbar addButton: closeBtn edge: #top.! !

!SdMethodEditor methodsFor: 'testing' stamp: 'mt 4/6/2011 16:23:36.804'!
isMethodEditor

	^ true! !

!SdMethodEditor methodsFor: 'layout' stamp: 'mt 4/8/2011 10:47:24.544'!
minExtent

	"WORKAROUND: Fix buggy layouting due to #minExtent implementation in some cases."
	self owner ifNotNil: [:o |
		self hResizing == #spaceFill ifTrue: [self width: self owner width].
		self vResizing == #spaceFill ifTrue: [self height: self owner height]].
	
	^ super minExtent! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:24:51.55'!
selector

	^ sourceCodeEdit selector! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 3/25/2011 11:58:34.431'!
selector: aSymbol

	sourceCodeEdit selector: aSymbol.
	self updateLayout.! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 4/6/2011 16:02:42.183'!
selectorText

	| result |
	result := self selector asString asText.
	result addAttribute: (TextFontReference toFont: (sourceCodeEdit textMorph textStyle defaultFont)).
	^ result
	! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 4/4/2011 15:10:26.493'!
sourceCodeEdit

	^ sourceCodeEdit! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 3/25/2011 11:58:43.581'!
theClass: aClassOrMetaClass selector: aSymbol

	sourceCodeEdit
		theClass: aClassOrMetaClass
		selector: aSymbol.
		
	self updateLayout.! !

!SdMethodEditor methodsFor: 'updating' stamp: 'mt 4/11/2011 11:29:54.148'!
updateLayout

	toggleBtn checked
		ifTrue: [
			toggleBtn
				disableTableLayout: true;
				hide.
			sourceCodeEdit
				disableTableLayout: false;
				reset;
				show;
				grabKeyboard.
			separator
				disableTableLayout: false;
				show.
			self toolbarVisible: true]
		ifFalse: [
			toggleBtn
				disableTableLayout: false;
				show;
				hResizing: #spaceFill;
				text: self selectorText;
				icon: (UiFugueIcons toggleSmallExpandIcon clippedTo: 9@16).
			sourceCodeEdit
				disableTableLayout: true;
				topLeft: self topLeft;
				hide.
			separator
				disableTableLayout: true;
				hide.
			self toolbarVisible: false].! !

SdClassElementEditor subclass: #SdMethodFinder
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/6/2011 13:32:06.819'!
chooseNextResult

	self ui resultList isEmpty ifTrue: [^ self].
	
	self ui resultList currentRow
		ifNil: [self ui resultList currentRow: 1]
		ifNotNil: [self ui resultList currentRow:
			(self ui resultList currentRow + 1 min: self ui resultList size)].
	
	self updateSearchField.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/6/2011 13:32:12.715'!
choosePrevResult

	self ui resultList isEmpty ifTrue: [^ self].
	
	self ui resultList currentRow
		ifNil: [self ui resultList currentRow: 1]
		ifNotNil: [self ui resultList currentRow:
			(self ui resultList currentRow - 1 max: 1)].
	
	self updateSearchField.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/6/2011 16:20:43.381'!
chooseSelector

	self currentSelector ifEmpty: [^ self].
	self selectorChosen: self currentSelector.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/6/2011 16:18:48.315'!
clear

	self ui searchField clear.
	self updateResults.! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 4/6/2011 15:53:08.82'!
currentSelector
		
	^ self ui searchField theText asString asSymbol! !

!SdMethodFinder methodsFor: 'updating' stamp: 'mt 4/11/2011 13:54:51.541'!
editorChange: aSymbol

	aSymbol = #class
		ifTrue: [self clear].! !

!SdMethodFinder methodsFor: 'events' stamp: 'mt 4/11/2011 11:17:08.337'!
grabKeyboard

	self ui searchField grabKeyboard.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/12/2011 13:07:55.435'!
hideResults

	self ui resultList visible ifFalse: [^ self].

	self ui resultList
		hide;
		disableTableLayout: true.! !

!SdMethodFinder methodsFor: 'initialization' stamp: 'mt 4/12/2011 14:23:08.326'!
initialize

	super initialize.

	self ui setupUi: self.
	self ui panel
		layoutInset: 0;  
		vResizing: #shrinkWrap.  
	
	self connect: self ui searchField signal: #textEdited: toSelector: #updateResults:.
	self connect: self ui resultList signal: #currentTextChanged: toSelector: #updateSearchField.
	self connect: self ui searchField signal: #textChanged: toSelector: #updateActionButton.

	self connect: self ui actionBtn signal: #clicked: toSelector: #chooseSelector.
	self connect: self ui searchField signal: #returnPressed: toSelector: #chooseSelector.
	self connect: self ui resultList signal: #doubleClicked: toSelector: #chooseSelector.
	
	"keyboard shortcuts"
	self ui searchField eventHandler on: Character arrowDown send: #chooseNextResult to: self.
	self ui searchField eventHandler on: Character arrowUp send: #choosePrevResult to: self.
	self ui searchField eventHandler on: Character escape send: #clear to: self.
	
	self
		color: (Color gray: 0.85);
		vResizing: #shrinkWrap;  
		updateResults;
		updateActionButton.! !

!SdMethodFinder methodsFor: 'signals' stamp: 'mt 4/6/2011 16:16:08.526'!
selectorChosen: aSymbol
	"Emitted whenever the user decided for a symbol. This can be a new one."
	
	self emit.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/12/2011 13:07:50.372'!
showResults

	self ui resultList visible ifTrue: [^ self].

	self ui resultList
		show;
		disableTableLayout: false.! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 4/6/2011 15:29:21.879'!
ui

	^ ui ifNil: [ui := SdMethodFinderUi new]! !

!SdMethodFinder methodsFor: 'updating' stamp: 'mt 4/12/2011 14:27:07.918'!
updateActionButton

	self theClass
		ifNil: [^ self ui actionBtn hide]
		ifNotNil: [self ui actionBtn show].
	
	self currentSelector ifEmpty: [^ self ui actionBtn hide].
	
	(self theClass canUnderstand: self currentSelector)
		ifTrue: [self ui actionBtn icon: UiSilkIcons pencilIcon]
		ifFalse: [self ui actionBtn icon: UiFugueIcons asteriskYellowIcon].! !

!SdMethodFinder methodsFor: 'updating' stamp: 'mt 4/6/2011 13:56:45.674'!
updateResults

	self updateResults: self ui searchField theText.  ! !

!SdMethodFinder methodsFor: 'updating' stamp: 'mt 4/11/2011 17:05:06.791'!
updateResults: stringOrText

	| token newResults |
	token := stringOrText asString asSymbol.

	(self theClass isNil or: [token isEmpty])
		ifTrue: [
			self ui resultList clear.
			^ self hideResults].

	newResults := (self theClass selectors select: [:selector | 
		token = '.' or: [selector startsWith: token]]) sorted.
	
	newResults = self ui resultList textList asArray
		ifTrue: [^ self].
	
	self ui resultList clear.
	
	self ui resultList
		addTextList: newResults.
		
	self ui resultList isEmpty
		ifTrue: [self hideResults]
		ifFalse: [self showResults].! !

!SdMethodFinder methodsFor: 'updating' stamp: 'mt 4/6/2011 14:39:44.676'!
updateSearchField
	"Completes the search field with the current text in the result list. Select that part that has not been typed yet."

	| userText i |
	self ui resultList currentText asString = self ui searchField theText asString
		ifTrue: [^ self].
	
	userText := self ui searchField theText asString allButLast: self ui searchField selectedText size.
	
	(self ui resultList currentText startsWith: userText)
		ifTrue: [i := userText size + 1].

	self ui searchField theText: self ui resultList currentText.
	
	i
		ifNil: [self ui searchField selectAll]
		ifNotNil: [self ui searchField select: (i to: self ui searchField theText size)].
			
	self ui searchField grabKeyboard.
! !

Morph subclass: #SdFadingToolbar
	instanceVariableNames: 'leftBar topBar rightBar bottomBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 14:59:47.001'!
addButton: aButton edge: aSymbol

	aSymbol = #left ifTrue: [leftBar addMorphBack: aButton].
	aSymbol = #top ifTrue: [topBar addMorphBack: aButton].
	aSymbol = #right ifTrue: [rightBar addMorphBack: aButton].
	aSymbol = #bottom ifTrue: [bottomBar addMorphBack: aButton].! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 14:48:29.386'!
alpha: aFloat
	
	leftBar alpha: aFloat.
	topBar alpha: aFloat.
	rightBar alpha: aFloat.
	bottomBar alpha: aFloat.! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 16:28:42.003'!
fullBounds

	fullBounds ifNil: [
		self updateLayout].
	^ super fullBounds! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 16:40:08.924'!
handleMouseMove: anEvent

	self mouseMove: anEvent.! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 17:01:51.113'!
initialize

	super initialize.

	self
		color: Color transparent;
		initializeEventHandler.
	
	leftBar := SdFadingToolbarPanel new orientation: #vertical; wrapDirection: #rightToLeft.  
	topBar := SdFadingToolbarPanel new orientation: #horizontal; wrapDirection: #bottomToTop.
	rightBar := SdFadingToolbarPanel new orientation: #vertical; wrapDirection: #leftToRight.
	bottomBar := SdFadingToolbarPanel new orientation: #horizontal; wrapDirection: #topToBottom.

	self addAllMorphs: {leftBar. topBar. rightBar. bottomBar}.! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 13:46:25.17'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self connect: self eventHandler signal: #mouseLeft: toSelector: #alpha: pattern: #(= 0.0).
	self connect: self eventHandler signal: #mouseMoved: toSelector: #updateAlpha:.
	self connect: self eventHandler signal: #mouseEntered: toSelector: #updateAlpha:.! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 17:14:13.551'!
popUpAt: aGlobalPoint

	ActiveWorld submorphs
		select: [:m | m isKindOf: SdFadingToolbar]  
		thenDo: [:m | m delete].
		
	self
		topLeft: aGlobalPoint;
		openInWorld.! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 16:45:39.314'!
rejectsEvent: anEvent

	(self bounds containsPoint: anEvent position)
		ifFalse: [^ super rejectsEvent: anEvent].

	^ (anEvent isMouse and: [
		anEvent isMouseMove
			or: [anEvent isMouseEnter]
			or: [anEvent isMouseLeave]]) not! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 16:55:21.953'!
updateAlpha: aMouseEvent

	(self bounds containsPoint: aMouseEvent position) ifTrue: [
		leftBar alpha: (1.0 - ((aMouseEvent position x - self left max: 0) / (self width / 2)) max: 0.3).
		topBar alpha: (1.0 - ((aMouseEvent position y - self top max: 0) / (self height / 2)) max: 0.3).
		rightBar alpha: (1.0 - ((self right - aMouseEvent position x max: 0) / (self width / 2)) max: 0.3).
		bottomBar alpha: (1.0 - ((self bottom - aMouseEvent position y max: 0) / (self height / 2)) max: 0.3)].! !

!SdFadingToolbar methodsFor: 'as yet unclassified' stamp: 'mt 4/7/2011 16:28:56.17'!
updateLayout
	"Simulate #spaceFill behaviour according to the bar's orientation."
	
	leftBar height: self height.
	topBar width: self width.
	rightBar height: self height.
	bottomBar width: self width.

	leftBar topRight: self topLeft.
	topBar bottomLeft: self topLeft.
	rightBar topLeft: self topRight.
	bottomBar topLeft: self bottomLeft.! !

Morph subclass: #SdFadingToolbarPanel
	instanceVariableNames: 'alpha orientation fadeEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdFadingToolbarPanel commentStamp: 'mt 6/21/2010 16:38:29.674' prior: 0!
I just support the XpfCardMorph. You should normally not want to use me directly.

Normally, I contain some buttons and fade them in or out according to my alpha value.!

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 6/21/2010 13:35:41.007'!
alpha

	^ alpha ifNil: [alpha := 0.0]! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 16:58:02.317'!
alpha: aFloat

	self submorphs
		ifEmpty: [alpha := 0.0]
		ifNotEmpty: [alpha := aFloat].

	self redrawLater.! !

!SdFadingToolbarPanel methodsFor: 'drawing' stamp: 'mt 4/11/2011 13:34:46.482'!
drawOn: aCanvas

	aCanvas
		fillRoundRect: (self submorphBounds outsetBy: 2)
		radius: 5
		fillStyle: (SolidFillStyle color: (Color black alpha: 0.5)).! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 6/21/2010 16:34:33.892'!
fadeEnabled 
	"Respect the alpha value while drawing?"
	
	^ fadeEnabled ifNil: [fadeEnabled := true]! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 6/21/2010 16:35:04.687'!
fadeEnabled: aBoolean

	aBoolean = fadeEnabled ifTrue: [^ self].
	
	fadeEnabled := aBoolean.
	self redrawLater.! !

!SdFadingToolbarPanel methodsFor: 'drawing' stamp: 'mt 6/21/2010 16:37:13.905'!
fullDrawOn: aCanvas

	self alpha = 0.0
		ifTrue: [^ self].

	(self alpha < 0.9 and: [self fadeEnabled])
		ifTrue: [^ super fullDrawOn: ((AnimAlphaBlendingCanvas on: aCanvas) alpha: self alpha)]
		ifFalse: [^ super fullDrawOn: aCanvas]! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/11/2011 13:30:21.295'!
initialize

	super initialize.
	
	self initializeEventHandler.
	
	self
		color: Color blue;
		changeTableLayout;
		cellInset: 2;
		layoutInset: 2;
		orientation: #vertical.! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/7/2011 17:53:39.679'!
initializeEventHandler

	self eventHandler: UiEventHandler new.  

	self eventHandler setProperty: #handlesMouseDown toValue: [false].

	self connect: self eventHandler signal: #mouseEntered: toSelector: #alpha: pattern: #(= 1.0).
	self connect: self eventHandler signal: #mouseLeft: toSelector: #alpha: pattern: #(= 0.0).
	self connect: self eventHandler signal: #mouseLeft: toSelector: #tryDelete:.! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:28:28.138'!
orientation

	^ orientation! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:28:45.026'!
orientation: aSymbol
	"#vertical #horizontal"

	aSymbol = orientation ifTrue: [^ self].

	orientation := aSymbol.
	
	self updateLayout.! !

!SdFadingToolbarPanel methodsFor: 'events-processing' stamp: 'mt 4/11/2011 16:16:45.314'!
rejectsEvent: evt

	(evt isMouse and: [evt isMouseLeave])
		ifTrue: [^ false].
		
	^ self alpha = 0.0 or: [super rejectsEvent: evt]! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/7/2011 17:49:39.259'!
tryDelete: aMouseEvent

	(self owner morphsAt: aMouseEvent position)
		ifEmpty: [self owner delete].! !

!SdFadingToolbarPanel methodsFor: 'layout' stamp: 'mt 4/11/2011 13:31:24.272'!
updateLayout

	self orientation = #vertical
		ifTrue: [self
			extent: 22@22;
			listDirection: #topToBottom].

	self orientation = #horizontal  
		ifTrue: [self
			extent: 22@22;
			listDirection: #leftToRight].! !

UiTestCase subclass: #SdMethodFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests'!

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 4/12/2011 12:55:20.495'!
test01Resizing

	| m |
	m := Morph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	sut
		theClass: String.
	
	m addMorph: sut.
	self assert: sut height equals: m height.! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 4/12/2011 12:59:27.046'!
test02New

	sut cellInset: 0.  
	self assert: sut ui searchField height equals: sut height.! !

BorderedMorph subclass: #SdIDE
	instanceVariableNames: 'callTreeView callTreeViewUi codeView addBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdIDE methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 17:01:39.317'!
addClassSelector

	codeView widget
		addMorph:	(SdClassEditor new vResizing: #spaceFill)
		inFrontOf: addBtn.! !

!SdIDE methodsFor: 'as yet unclassified' stamp: 'mt 4/12/2011 14:25:34.323'!
initialize

	super initialize.
	
	self changeProportionalLayout.
	
	callTreeView := Morph new.
	codeView := UiScrollArea new.

	callTreeViewUi := SdCallTreePanelUi new.
	callTreeViewUi setupUi: callTreeView.
	
	self connect: callTreeViewUi testClassCmb signal: #currentTextChanged: toSelector: #updateTestCombo:.
	self connect: callTreeViewUi testCmb signal: #currentTextChanged: toSelector: #traceCurrentTest.
	
	codeView
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		verticalScrollBarPolicy: #alwaysOff;
		horizontalScrollBarPolicy: #asNeeded;  
		widgetResizable: true;
		widget: (Morph new color: (Color gray: 0.85)).
		
	codeView widget
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		cellPositioning: #topLeft.
	
	addBtn := UiToolButton new
		autoRaise: true;
		buttonStyle: #iconOnly;
		icon: UiSilkIcons addIcon;
		balloonText: 'Add class view';
		layoutInset: (2@5 corner: 2@5).
	self connect: addBtn signal: #clicked: toSelector: #addClassSelector.
	codeView widget addMorphBack: addBtn.
	
	callTreeView
		hResizing: #spaceFill;
		vResizing: #spaceFill.  
		
	"Layout"
	callTreeView frameFractions: (0@0 corner: 0.3@1.0).
	codeView frameFractions: (0.3@0 corner: 1.0@1.0)  .
	
	self
		color: (Color blue muchLighter);
		addMorph: callTreeView;
		addMorph: codeView;
		addPaneSplitters.
	
	callTreeViewUi testClassCmb addTextList:
		((PackageInfo named: #'Widgets-Tests') classes
			select: [:class | class inheritsFrom: UiTestCase]
			thenCollect: [:uiTestClass | uiTestClass name]).! !

!SdIDE methodsFor: 'as yet unclassified' stamp: 'mt 3/29/2011 18:40:32.696'!
open

	self extent: 500@300.

	self openInWindowLabeled: 'Sight Dynamic IDE'.! !

!SdIDE methodsFor: 'as yet unclassified' stamp: 'mt 3/30/2011 10:13:13.878'!
traceCurrentTest

	| cgt tree testClass testMethodSelector |
	callTreeViewUi callTree model: nil.
	
	testClass := Smalltalk at: callTreeViewUi testClassCmb currentText asString asSymbol ifAbsent: [^ self].
	testMethodSelector := callTreeViewUi testCmb currentText asString asSymbol.
	
	"cgt := SdCallgraphTracer new.
	cgt profilingMode: #ms.
	cgt selectedCategories: (
		(PackageInfo named: #Widgets) systemCategories,
		(PackageInfo named: #Designer) systemCategories,
		(PackageInfo named: #'Sight-Dynamic') systemCategories).
	cgt callgraphModel: SdCallgraph new.
	cgt traceTest: testClass method: testMethodSelector.
	
	callTreeViewUi callTree
		model: (SdCallgraphModel new root: cgt callgraphModel);
		setHAlignmentForColumn: 2 to: #right."
	! !

!SdIDE methodsFor: 'as yet unclassified' stamp: 'mt 3/30/2011 10:04:38.236'!
updateTestCombo: aTestClassName

	callTreeViewUi testCmb clear.

	(aTestClassName isNil or: [aTestClassName isEmpty])
		ifTrue: [^ self].

	callTreeViewUi testCmb
		addTextList: (Smalltalk at: aTestClassName asString asSymbol) testSelectors.! !

UiTextEdit subclass: #SdSourceCodeEdit
	instanceVariableNames: 'theClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSourceCodeEdit commentStamp: 'mt 3/24/2011 11:22:15.769' prior: 0!
This is a text edit to modify a method's source.!

!SdSourceCodeEdit class methodsFor: 'testing' stamp: 'mt 3/25/2011 17:07:38.3'!
isWidgetClass

	^ false! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/11/2011 10:17:38.635'!
acceptChanges

	self hasUnacceptedChanges
		ifFalse: [^ self].
		
	(self parse and: [self compile])
		ifTrue: [^ super acceptChanges].
		
	self grabKeyboard.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/11/2011 09:44:55.408'!
checkSelector
	"Check current selector and reload source if necessary."
	
	self selector: (Compiler parserClass new parseSelector: self theText asString).! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/11/2011 09:45:33.703'!
compile

	[self theClass
		compile: self theText
		classified: (MethodReference
			class: self theClass
			selector: self selector) category.
			
	self checkSelector.
	
	^ true]
		on: SyntaxErrorNotification "Manual catch to disable interactive compilation."
		do: [:err | 
			Transcript cr; show: '[Syntax] ', err asString.
			(SdMessageEvent
				text: 'Compilation failed: ', self theClass asString, ' >> ', self selector asString
				kind: #warning
				class: self theClass) trigger.
				
			self notify: err errorMessage at: err location in: err messageText.
			
			^ false]
		on: Error
		do: [:err |
			Transcript cr; show: '[Error] ', err asString.
			(SdMessageEvent
				text: 'Compilation error: ', self theClass asString, ' >> ', self selector asString
				kind: #error
				class: self theClass) trigger.
				
			^ false].! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 4/8/2011 11:18:33.265'!
focusChanged: aRectangle

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'initialization' stamp: 'mt 4/8/2011 12:09:38.881'!
initialize

	super initialize.
	
	self textMorph font: Preferences standardCodeFont.
	self textMorph styler: SHTextStylerST80 new.
	
	self connect: self textMorph signal: #focusChanged: toSelector: #onFocusChanged:.

	self connect: self eventHandler signal: #mouseWheelUp: toSelector: #mouseWheelUp:.
	self connect: self eventHandler signal: #mouseWheelDown: toSelector: #mouseWheelDown:.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 4/8/2011 11:31:51.12'!
mouseWheelDown: aMouseEvent

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 4/8/2011 11:31:41.523'!
mouseWheelUp: aMouseEvent

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/10/2011 12:20:28.782'!
notify: aMessage at: aLocation in: aSource

	| message |
	self textMorph editor selectAt: aLocation.
	
	"Trigger manual focus changes. Should be automatic on selection changed?"
	self onFocusChanged: (self textMorph editor pointBlock).
	
	message := ((UiMessage information: aMessage)
		topLeft: (self textMorph localPointToGlobal: (self textMorph editor pointBlock bottomLeft))).
	message openInWorld.! !

!SdSourceCodeEdit methodsFor: 'focus' stamp: 'mt 4/8/2011 12:13:17.821'!
onFocusChanged: aLocalRectangle

	self focusChanged:
		((self textMorph localPointToGlobal: aLocalRectangle topLeft)
		extent: aLocalRectangle extent).! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/11/2011 10:34:19.586'!
parse

	| helper |
	helper := SdParserHelper new
		text: self theText;
		view: self.
	
	[Parser new
		parse: self theText asString readStream
		class: self theClass
		category: (MethodReference
			class: self theClass
			selector: self selector) category
		noPattern: false
		context: nil
		notifying: helper
		ifFail: [^ false]]
		on: ParserNotification "Manual catch to disable interactive compilation."
		do: [:err |
			(err isKindOf: UnusedVariable) ifTrue: [
				(SdMessageEvent
					text: 'Unused Variable found: ', self theClass asString, ' >> ', self selector asString
					kind: #information
					class: self theClass) trigger.

				err resume: false].
			
			(SdMessageEvent
				text: 'Parsing failed: ', self theClass asString, ' >> ', self selector asString
				kind: #warning
				class: self theClass) trigger.
				
			self notify: err class name at: helper selection first in: self theText.
			self select: helper selection.
			
			^ false].
		
	^ true! !

!SdSourceCodeEdit methodsFor: 'initialization' stamp: 'mt 4/11/2011 11:02:29.4'!
reset

	self theClass ifNil: [^ self].

	self textMorph styler classOrMetaClass: self theClass.  	
	
	(self theClass includesSelector: self selector)
		ifTrue: [self theText: (self theClass >> self selector) getSource]
		ifFalse: [self theText: self selector].! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:01:21.227'!
selector

	^ selector! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/25/2011 11:56:38.599'!
selector: aSymbol

	selector := aSymbol.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 3/24/2011 11:37:39.359'!
sourceCodeResetted

	self emit.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:01:05.836'!
theClass

	^ theClass! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/25/2011 11:56:42.188'!
theClass: aClassOrMetaClass

	theClass := aClassOrMetaClass.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/25/2011 11:56:45.885'!
theClass: aClassOrMetaClass selector: aSymbol

	theClass := aClassOrMetaClass.
	selector := aSymbol.! !

Object subclass: #SdFoobar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Testbed'!

!SdFoobar commentStamp: '<historical>' prior: 0!
Hello, World!!!

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 13:35:40.753'!
a: aKey b: anotherKey
	"This is an example."! !

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 4/12/2011 13:57:06.501'!
blubb! !

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 11:34:22.281'!
foobar
	Transcript show.
	
"Hello, World!!
what'

Hahah!!!!!!!!"

"ich glaub, ich spinne!!"

Transcript! !

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 11:48:04.394'!
foobar2

	"hmmmmmm"! !

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 4/12/2011 14:27:48.633'!
foobar3

	"This is foobar."
	| a |
	false ifTrue: [a := 7].
	Transcript show: 'hello, world!!', a.! !

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 11:01:15.005'!
foobar4

	"Helelo"! !

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 11:47:30.826'!
hello

	"Treeg"! !

Object subclass: #SdFoobar2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Testbed'!

Object subclass: #SdFoobar3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Testbed'!

Object subclass: #SdParserHelper
	instanceVariableNames: 'text view selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdParserHelper commentStamp: 'mt 4/11/2011 09:38:06.258' prior: 0!
Used for notification of default parser.!

!SdParserHelper methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 10:20:42.362'!
notify: aMessage at: aLocation in: aSource

	self view
		notify: (aMessage allButLast: 3)
		at: aLocation
		in: aSource.! !

!SdParserHelper methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 09:56:44.834'!
select
! !

!SdParserHelper methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 10:13:37.356'!
selectFrom: startIndex to: endIndex

	self selection: (startIndex to: endIndex).! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 10:13:18.346'!
selection

	^ selection! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 10:13:26.415'!
selection: anInterval

	selection := anInterval.! !

!SdParserHelper methodsFor: 'as yet unclassified' stamp: 'mt 4/11/2011 09:40:44.679'!
selectionInterval

	^ 1 to: 0! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:41:19.665'!
text

	^ text! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:41:26.804'!
text: stringOrText

	text := stringOrText.! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:46:17.653'!
view

	^ view! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:46:25.661'!
view: aMorph

	view := aMorph.! !

UiItemModel subclass: #SdCallgraphModel
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdCallgraphModel commentStamp: 'mt 3/23/2011 14:44:06.545' prior: 0!
| cgt tree |
cgt := SdCallgraphTracer new.
cgt profilingMode: #ms.
cgt selectedCategories: (PackageInfo named: #Widgets) systemCategories.
cgt callgraphModel: SdCallgraph new.
cgt traceSourceCode: 'UiTextEdit new'.
tree := UiTreeView new model: (SdCallgraphModel new root: cgt callgraphModel).
tree openInWorld.!

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/23/2011 14:40:22.991'!
columnCountFor: aParentModelIndex

	^ 2! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/23/2011 14:40:50.752'!
iconFor: aModelIndex

	(aModelIndex row = 0 or: [aModelIndex column = 0])
		ifTrue: [^ nil].
	
	aModelIndex column = 2
		ifTrue: [^ nil].
	
	^ (aModelIndex valueOfProperty: #snode) ifNotNil: [:snode |
		(snode clientClass inheritsFrom: Morph)
			ifTrue: [snode clientClass widgetClassIcon]
			ifFalse: [nil]]! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/28/2011 11:46:06.509'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	| index snode |
	index := (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex.
		
	"Header indices."
	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ index].
		
	snode := aParentModelIndex
		ifNil: [self root rootNode]
		ifNotNil: [aParentModelIndex valueOfProperty: #snode].
		
	index
		setProperty: #snode
		toValue: (snode nextCalls at: aRowNumber).
		
	^ index! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/28/2011 11:41:25.33'!
root

	^ root! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/28/2011 11:41:34.653'!
root: anSNode

	root := anSNode.! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/4/2011 11:51:19.778'!
rowCountFor: aParentModelIndex

	^ (aParentModelIndex
		ifNil: [self root rootNode ifNil: [^0]]
		ifNotNil: [:p | p valueOfProperty: #snode]) nextCalls size! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 3/23/2011 14:46:41.336'!
textFor: aModelIndex

	aModelIndex row = 0 ifTrue: [
		aModelIndex column = 1 ifTrue: [^ 'CallTree'].
		aModelIndex column = 2 ifTrue: [^ 'Time (ms)']].
	aModelIndex column = 0 ifTrue: [^ ''].
	
	aModelIndex column = 1 ifTrue: [
		^ (aModelIndex valueOfProperty: #snode) ifNotNil: [:snode |
			('{1}\\>\\><b>{2}</b>' format: {snode clientClass name. snode clientSelector}) asHtmlText]].
	
	aModelIndex column = 2 ifTrue: [
		^ (aModelIndex valueOfProperty: #snode) ifNotNil: [:snode |
			(snode profiles at: #ms ifAbsent: ['ms']) allButLast: 2]].! !

UiItemModel subclass: #SdClassTreeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdClassTreeModel methodsFor: 'counts' stamp: 'mt 4/11/2011 14:22:44.959'!
columnCountFor: aParentModelIndex  

	^ 1! !

!SdClassTreeModel methodsFor: 'model data' stamp: 'mt 4/11/2011 14:29:35.837'!
iconFor: aModelIndex

	^ nil! !

!SdClassTreeModel methodsFor: 'index generation' stamp: 'mt 4/11/2011 14:25:07.643'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	| index |
	index := (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex.
	
	"Header indices."
	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ index].
	
	aParentModelIndex ifNil: [
		index setProperty: #package toValue: (PackageOrganizer default packages at: aRowNumber).
		^ index].
	
	(aParentModelIndex includesProperty: #package) ifTrue: [
		index
			setProperty: #systemCategory
			toValue: ((aParentModelIndex valueOfProperty: #package) systemCategories at: aRowNumber).
		index
			setProperty: #systemCategoryPrefix
			toValue: (aParentModelIndex valueOfProperty: #package) systemCategoryPrefix.
		^ index].
	
	(aParentModelIndex includesProperty: #systemCategory) ifTrue: [
		index
			setProperty: #class
			toValue: ((SystemOrganization
				listAtCategoryNamed: (aParentModelIndex valueOfProperty: #systemCategory))
				at: aRowNumber).
		^ index].! !

!SdClassTreeModel methodsFor: 'initialize-release' stamp: 'mt 4/11/2011 14:49:07.869'!
initialize

"	SystemChangeNotifier uniqueInstance
		notify: self ofAllSystemChangesUsing: #processNotification:."! !

!SdClassTreeModel methodsFor: 'notifications' stamp: 'mt 4/11/2011 14:31:07.649'!
processNotification: anEvent

	| pkg pkgIndex sysIndex classIndex |
	(anEvent itemKind ~= #category and: [anEvent itemKind ~= #class])
		ifTrue: [^ self].
	
	pkg := PackageOrganizer default
		packageOfSystemCategory: anEvent itemCategory
		ifNone: [^ self].
	pkgIndex := (UiSimpleModelIndex
		row: (PackageOrganizer default packages indexOf: pkg)
		column: 1)
		model: self;
		setProperty: #package toValue: pkg.
	sysIndex := self
		indexRow: (pkg systemCategories indexOf: anEvent itemCategory)
		column: 1
		parent: pkgIndex.
	classIndex := self
		indexRow: ((SystemOrganization listAtCategoryNamed: anEvent itemCategory) indexOf: anEvent itemClass name)
		column: 1
		parent: sysIndex.
	
	anEvent itemKind = #category ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRenamed ifTrue: [
			sysIndex := self
				indexRow: (pkg systemCategories indexOf: anEvent newName)
				column: 1
				parent: pkgIndex.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]].

	anEvent itemKind = #class ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row].
		anEvent isRenamed ifTrue: [
			self rowsChangedFor: sysIndex from: classIndex row to: classIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]
		].! !

!SdClassTreeModel methodsFor: 'counts' stamp: 'mt 4/11/2011 14:24:21.631'!
rowCountFor: aParentModelIndex
	
	aParentModelIndex ifNil: [
		^ PackageOrganizer default packages size].
	
	aParentModelIndex column ~= 1 ifTrue: [^ 0].
	
	(aParentModelIndex includesProperty: #package) ifTrue: [
		^ (aParentModelIndex valueOfProperty: #package) systemCategories size].
	
	(aParentModelIndex includesProperty: #systemCategory) ifTrue: [
		^ (SystemOrganization
				listAtCategoryNamed: (aParentModelIndex valueOfProperty: #systemCategory)) size].
		
	^ 0! !

!SdClassTreeModel methodsFor: 'model data' stamp: 'mt 4/11/2011 14:30:10.005'!
textFor: aModelIndex

	| col package systemCategory class |
	col := aModelIndex column.
	package := aModelIndex valueOfProperty: #package ifAbsent: [].
	systemCategory := aModelIndex valueOfProperty: #systemCategory  ifAbsent: [].
	class := aModelIndex valueOfProperty: #class ifAbsent: [].
	
	col ~= 1 ifTrue: [^ nil].
	
	"Horizontal headers."
	aModelIndex row = 0 ifTrue: [^ '<b>Name</b>' asHtmlText].
	
	package ifNotNil: [:p | ^ p name].	
	systemCategory ifNotNil: [:cat | 
		| prefix |
		prefix := aModelIndex valueOfProperty: #systemCategoryPrefix.
			
		cat = prefix ifFalse: [cat := cat allButFirst: prefix size + 1].
		^ cat].
	
	class ifNotNil: [:c | ^ ('<b>', c, '</b>') asHtmlText].
		
	^ nil! !
